/* Modified clh 90/11/11, wrong 1:10000 numbering */
/* Modified tbr 90/11/21, another numbering fix */

#include <stdio.h>
#include <ctype.h>
#include "/usr/local/include/tfictypes.h"

char *prog_name;
int num_coords;

   /* Seconds west and north from the SE corner of a 1:10,000 map,
      in order of generated TICS. (Seconds multiplied by 2 for
      1:20,000 maps.)  TICS are (TFIC convention):
            3  7  4
            6  9  8
            2  5  1   */
                          /* SE  SW  NW  NE   S   W   N   E   C */
static hword sec_west[]  = {  0,360,360,  0,180,360,180,  0,180};
static hword sec_north[] = {  0,  0,180,180,  0, 90,180, 90, 90};

void bcgs2geo(map,fd)
      char *map;
      FILE *fd;
  {/* write the geographic coordinates of bcgs map to fd in
      the order se,sw,nw,ne (see above) as:
        -cm
        1 lat long
        2 lat long
        3 lat long
        4 lat long               */
   int dx,mx,dy,my;
   int dw,mw,sw,dn,mn,sn,n,c,nd,s,q;
   /* map name is in form dddlddd[[.]d], where last part is 1-origin index into
      10x10 grid of 1:20,000 mapsheets */
   /* pick up first part + letter */
   for (n = 0;  isdigit(c = *map++);  )
     {n = n * 10 + (c - '0');}
   if (islower(c))
     {c = toupper(c);}
   c -= 'A';
   /* compute degrees for southeast corner of grid from first part + letter */
   dx = 48 + 2 * (4 * (n/10) + ((((c>>2) & 0x1) * 0x3) ^ (c&0x3)));
   dy = 40 + 4 * (n%10) + (c>>2);
   /* write the negative of the UTM central meridian */
   fprintf(fd,"%d\n",-(3+6*(dx/6)));
   /* add last number */
   nd = 0;
   for (n = 0;  isdigit(c = *map++) && ++nd <= 3;  )
     {n = n * 10 + (c - '0');}
   if (c == '.')
     {c = *map++;}
   if (isdigit(c))
     {/* 1:10,000 - compute quadrant (0-origin) */
      /*   quadrants  2  3
                      0  1   */
      s = 1;  q = c - '1';}
   else
     {/* 1:20,000 - quadrant is SE, but multiply all secs by 2 */
      s = 2;  q = 1; /* tbr: Was q = 0; */}
   n -= 1;  /* get rid of 1-origin */
   /* each 1:20,000 map is 12 minutes wide, each quadrant is 6 */
   /* clh: Was mx = 12 * (9 - (n%10)) + 6 * (0x1 & q); */
   mx = 12 * (9 - (n%10)) + 6 * (0x1 & (q + 1));
   dx += mx / 60;  mx %= 60;
   /* and 6 minutes high (quadrants are 3)
      (so SE corner cannot "carry" into degrees) */
   my = 6 * (n/10) + 3 * (0x1 & (q >> 1));
   dy += my / 60;  my %= 60;  /* but a little paranoia never hurt... */
   /* compute coordinates */
   for (c = 0;  c < num_coords;  c++)
     {sn = sec_north[c] * s;
      mn = my + sn / 60;  sn %= 60;
      dn = dy + mn / 60;  mn %= 60;
      sw = sec_west[c] * s;
      mw = mx + sw / 60;  sw %= 60;
      dw = dx + mw / 60;  mw %= 60;
      fprintf(fd,"%d   %2d %2d %2d   %2d %2d %2d\n",c+1,dn,mn,sn,dw,mw,sw);}}

   /* globals for getopt() */

int optind, opterr;
char *optarg;
extern int getopt();

void usage()
  {fprintf(stderr,"usage: %s [-49] map ...\n",prog_name);
   exit(1);}

void main(argc,argv)
      int argc;
      char *argv[];
  {/* convert args to geo coords */
   int m,c;
   prog_name = argv[0];
   num_coords = 4;
   optind = 1;  opterr = 1;
   while ((c = getopt(argc,argv,"49")) != EOF)
     {switch (c)
        {case '9':
            num_coords = 9;
            break;
         case '4':
            num_coords = 4;
            break;
         case '?':
            usage();}}
   for (m = optind;  m < argc;  )
     {bcgs2geo(argv[m++],stdout);}}
