      SUBROUTINE DMSRAD (RAD,IDEG,IMIN,SEC,IOPT)
C
C         NAME:         DMSRAD
C
C         TYPE:         SUBROUTINE
C
C         FUNCTION:     CONVERT RADIANS FROM/TO DEGREES,MINUTES,SECONDS
C
C         VERSION:      VERSION1 (IBM)
C
C         DATE:         JANUARY 1981
C
C         ANALYST:      K.W.SCHUURMAN
C
C         STATEMENT:    CALL DMSRAD(RAD,IDEG,IMIN,SEC)
C
C                       NAME   I/O DESCRIPTION
C                       ----   --- -----------
C
C                       RAD    I/O ANGLE IN RADIANS
C                       IDEG   I/O DEGREES
C                       IMIN   I/O MINUTES
C                       SEC    I/O SECONDS
C                       IOPT    I    = -1 RADIANS TO DEGREES,MINUTES,SEC
C                                       1 DEGREES,MINUTES,SECONDS TO RAD
C
C         LANGUAGE:     FORTRAN G1
C
C         EXTERNALS:    NONE
C
      IMPLICIT REAL*8 (A-H,O-Z)
      PIBY= DATAN( 1.D0 ) / 45.D0
      IF( IOPT .EQ. 1 ) GO TO 10
C
C         RADIANS TO DEG,MIN,SEC
C
      DEG=DABS(RAD)/PIBY
      IDEG=DEG
      F=(DEG-IDEG)*60.D0
      IMIN=F
      SEC=(F-IMIN)*60.D0
      IF(DABS(SEC-60.D0) .GT. 1.D-6) GO TO 1
      SEC=0.0D0
      IMIN=IMIN+1
      IF(IMIN.NE.60)GO TO 1
      IMIN=0
      IDEG=IDEG+1
    1 CONTINUE
      IDEG=IDEG*DSIGN(1.D0,RAD)
      IF( IDEG.EQ.0) IMIN=IMIN*DSIGN(1.D0,RAD)
      IF(IMIN.EQ.0 .AND. IDEG.EQ.0)SEC=SEC*DSIGN(1.D0,RAD)
      GO TO 20
   10 CONTINUE
C
C         DEG,MIN,SEC TO RADIANS
C
      DEG=IABS(IDEG) + IABS(IMIN)/60.D0 + DABS(SEC)/3600.D0
      RAD=DEG*PIBY
      RAD=RAD*ISIGN(1,IDEG)
      IF(IDEG .EQ. 0)RAD=RAD*ISIGN(1,IMIN)
      IF(IDEG.EQ.0 .AND. IMIN.EQ.0)RAD=RAD*DSIGN(1.D0,SEC)
   20 RETURN
      END
