C ===================================================================
        PROGRAM g2uf
C ===================================================================
C       Machine: ..........................  DATA GENERAL MV/7800
C       O/S: ..............................  AOS/VS ver 3.00.00
C       Language: .........................  Fortran 77 (DG ver)
C       Site: .............................  AERO GEOMETRICS
C       Programmer: .......................  Rob Huntley (682-3439)
C
C =====================================================================
C
C       VARIABLE DECLARATIONS
        REAL *4 DS,LS
        IMPLICIT REAL*8 (X-Z)
        INTEGER *4 ICM,IKOUNT
        INTEGER *4 IDD,ILD,IDUMMY,IDM,ILM,IDS,ILS
C
  800   continue
        PRINT*,'input central meridian  (99 to exit) ...'
        READ(5,120,END=999)ICM
        IF (ICM .EQ. 99) THEN
                GO TO 999
        END IF
        ICM = -ICM
C
 5      WRITE(6,10)
 10     FORMAT(' ENTER LAT DDMMSS.SS: ',$)
        READ(5,15,END=999)ILD,ILM,LS
 15     FORMAT(I2,I2,F8.4)
CIF (ILD .EQ. 99) THEN
C       GO TO 999
CEND IF
C       PRINT*,ILD,ILM,LS
        WRITE(6,20)
 20     FORMAT(' ENTER LONG DDDMMSS.SS: ',$)
        READ(5,25,END=999)IDD,IDM,DS
 25     FORMAT(I3,I2,F8.4)
C       PRINT*,IDD,IDM,DS
        idd = -idd
C
 120    FORMAT(I3)
CICM = ICM * (-1)
CPRINT*,'ICM= ',ICM
C
C
        Z=0.0
        IDUMMY=0
        IDS=0
        ILS=0
        xx1=17.3
        CALL GEOTST(ILD,ILM,LS,IDD,IDM,DS,ICM,XX1,YY1)
        WRITE(6,35) XX1,YY1
  35    FORMAT (' X=',F12.3,10X,'Y=',F12.3)
C
        goto 800
  801   continue
  999   STOP
        END
C
C ================================================================
        SUBROUTINE GEOTST (IPD,IPM,PS,IOD,IOM,OS,ICM,X,Y)
C ================================================================
C       
C
C
        IMPLICIT REAL*8 (A-H,O-Z)
        IMPLICIT INTEGER*4 (I-N)
        XO = 500000.D0
        YO = 0.D0   
C       ICM =-129
C       PRINT*,'IOM=',IOM
        SF = 0.9996D0    
        A = 6378137.D0  
        B = 6356752.31D0
CICM = ICM * (-1)
CPS=0
CPRINT*,IPD,IPM,PS,' 1 '
COS=0
C     PRINT*,IOD,IOM,OS,' 2 '
        IDUMMY = 0
        ADUMMY = 0.
        CALL DMSRAD     (CMRAD,ICM,IDUMMY,ADUMMY,1)
        CALL DMSRAD     (PHI,IPD,IPM,PS,1)
        CALL DMSRAD     (OLAM,IOD,IOM,OS,1)
C       PRINT*,PHI,OLAM,A,B,SF,CMRAD
        CALL TMPLXY(PHI,OLAM,A,B,SF,XO,YO,CMRAD,X,Y)
C       WRITE (6,25)X,Y
25      FORMAT (/,' X=',F12.3,10X,'Y=',F12.3,/)
        x1 = x
        y1 = y
        CALL TMXYPL(X1,Y1,A,B,SF,XO,YO,CMRAD,PHI,OLAM)
C       WRITE (6,25)X1,Y1
        CALL DMSRAD     (PHI,IPD,IPM,PS,-1)
        CALL DMSRAD     (OLAM,IOD,IOM,OS,-1)
        WRITE (6,30)IPD,IPM,PS,IOD,IOM,OS
30      FORMAT  (2I4,F7.3,10X,2I4,F7.3)
999     RETURN
        END
C
      SUBROUTINE DMSRAD (RAD,IDEG,IMIN,SEC,IOPT)
C
C         NAME:         DMSRAD
C
C         TYPE:         SUBROUTINE
C
C         FUNCTION:     CONVERT RADIANS FROM/TO DEGREES,MINUTES,SECONDS
C
C         VERSION:      VERSION1 (IBM)
C
C         DATE:         JANUARY 1981
C
C         ANALYST:      K.W.SCHUURMAN
C
C         STATEMENT:    CALL DMSRAD(RAD,IDEG,IMIN,SEC)
C
C                       NAME   I/O DESCRIPTION
C                       ----   --- -----------
C
C                       RAD    I/O ANGLE IN RADIANS
C                       IDEG   I/O DEGREES
C                       IMIN   I/O MINUTES
C                       SEC    I/O SECONDS
C                       IOPT    I    = -1 RADIANS TO DEGREES,MINUTES,SEC
C                                       1 DEGREES,MINUTES,SECONDS TO RAD
C
C         LANGUAGE:     FORTRAN G1
C
C         EXTERNALS:    NONE
C
      IMPLICIT REAL*8 (A-H,O-Z)
      PIBY= DATAN( 1.D0 ) / 45.D0
      IF( IOPT .EQ. 1 ) GO TO 10
C
C         RADIANS TO DEG,MIN,SEC
C
      DEG=DABS(RAD)/PIBY
      IDEG=DEG
      F=(DEG-IDEG)*60.D0
      IMIN=F
      SEC=(F-IMIN)*60.D0
      IF(DABS(SEC-60.D0) .GT. 1.D-6) GO TO 1
      SEC=0.0D0
      IMIN=IMIN+1
      IF(IMIN.NE.60)GO TO 1
      IMIN=0
      IDEG=IDEG+1
    1 CONTINUE
      IDEG=IDEG*DSIGN(1.D0,RAD)
      IF( IDEG.EQ.0) IMIN=IMIN*DSIGN(1.D0,RAD)
      IF(IMIN.EQ.0 .AND. IDEG.EQ.0)SEC=SEC*DSIGN(1.D0,RAD)
      GO TO 20
   10 CONTINUE
C
C         DEG,MIN,SEC TO RADIANS
C
      DEG=IABS(IDEG) + IABS(IMIN)/60.D0 + DABS(SEC)/3600.D0
      RAD=DEG*PIBY
      RAD=RAD*ISIGN(1,IDEG)
      IF(IDEG .EQ. 0)RAD=RAD*ISIGN(1,IMIN)
      IF(IDEG.EQ.0 .AND. IMIN.EQ.0)RAD=RAD*DSIGN(1.D0,SEC)
   20 RETURN
      END
      SUBROUTINE FPLAT(A,B,Y,PHI1)
C***********************************************************************
C*
C*       THIS ROUTINE COMPUTES THE FOOT-POINT LATITUDE REQUIRED IN
C*     TRANSFORMING TRANSVERSE MERCATOR PLANE COORDINATES X,Y TO
C*     ELLIPSOIDAL COORDINATES.
C*
C*
C*       INPUT:
C*             A    - SEMI-MAJOR AXES OF THE REFERENCE ELLIPSOID.
C*             B    - SEMI-MINOR AXES OF THE REFERENCE ELLIPSOID.
C*             Y    - NORTHING OF THE POINT FOR WHICH THE FOOT-POINT
C*                    LATITUDE IS TO BE COMPUTED.
C*
C*       OUTPUT:
C*             PHI1 - FOOT-POINT LATITUDE IN RADIANS.
C*
C*
C*                                     WRITTEN BY:
C*                                         R.R. STEEVES, JUNE, 1977
C*
C***********************************************************************
      IMPLICIT REAL*8(A-Z)
      F(PHI)=A*(A0*PHI-A2*DSIN(2.D0*PHI)+A4*DSIN(4.D0*PHI)-A6*DSIN(6.D0*
     1       PHI)+A8*DSIN(8.D0*PHI))-Y
      FP(PHI)=A*(A0-2.D0*A2*DCOS(2.D0*PHI)+4.D0*A4*DCOS(4.D0*PHI)-6.D0*
     1        A6*DCOS(6.D0*PHI)+8.D0*A8*DCOS(8.D0*PHI))
      E2=(A*A-B*B)/(A*A)
      E4=E2*E2
      E6=E4*E2
      E8=E6*E2
      A0=1.D0-E2/4.D0-3.D0*E4/64.D0-5.D0*E6/256.D0-175.D0*E8/16384.D0
      A2=3.D0/8.D0*(E2+E4/4.D0+15.D0*E6/128.D0-455.D0*E8/4096.D0)
      A4=15.D0/256.D0*(E4+3.D0*E6/4.D0-77.D0*E8/128.D0)
      A6=35.D0/3072.D0*(E6-41.D0*E8/32.D0)
      A8=-315.D0*E8/131072.D0
      PHI1=Y/A
    1 DPHI=F(PHI1)/FP(PHI1)
      PHI1=PHI1-DPHI
      IF(DABS(DPHI).LT.1.D-11)GOTO 2
      GO TO 1
    2 CONTINUE
      RETURN
      END
      SUBROUTINE MERARC( PHI, A, B, S )
C
C         NAME:       MERARC
C
C         TYPE:       SUBROUTINE
C
C         FUNCTION:   COMPUTES THE MERIDIAN ARC LENGTH FROM THE EQUATOR
C                     TO THE LATITUDE PHI ON THE ELLIPSOID DEFINED BY
C                     THE PARAMETERS A AND B.
C
C         NOTE:       THE COMPUTED ARC LENGTH IS ACCURATE TO APPROXIMATE
C                     10 MICROMETRES OVER THE ENTIRE RANGE: EQUATOR TO P
C
C         VERSION:    VERSION 1  (IBM)
C
C         DATE:       MAY 1977
C
C         ANALYST     R.R.STEEVES AND G.BOWIE
C
C         STATEMENT:  CALL MERARC( PHI, A, B, S )
C
C                     NAME   I/O DESCRIPTION
C                     ----   --- -----------
C
C                     PHI     I  ELLIPSOID LATITUDE IN RADIANS (POSITIVE
C                     A       I  SEMI-MAJOR AXIS OF ELLIPSOID
C                     B       I  SEMI-MINOR AXIS OF ELLIPSOID
C                     S       O  MERIDIAN ARC LENGTH
C
C         LANGUAGE:   FORTRAN G1
C
C         EXTERNALS:  NONE
C
      IMPLICIT REAL*8(A-Z)
      E2=(A*A-B*B)/(A*A)
      E4=E2*E2
      E6=E4*E2
      E8=E6*E2
      A0=1.0D0-E2/4.D0-3.D0*E4/64.D0-5.D0*E6/256.D0-175.D0*E8/16384.D0
      A2=3.D0/8.D0*(E2+E4/4.D0+15.D0*E6/128.D0-455.D0*E8/4096.D0)
      A4=15.D0/256.D0*(E4+3.D0*E6/4.D0-77.D0*E8/128.D0)
      A6=35.D0/3072.D0*(E6-41.D0*E8/32.D0)
      A8=-315.D0*E8/131072.D0
      S=A*(A0*PHI-A2*DSIN(2.D0*PHI)+A4*DSIN(4.D0*PHI)-A6*DSIN(6.D0*PHI)
     1  +A8*DSIN(8.D0*PHI))
      RETURN
      END
      SUBROUTINE TMXYPL(X,Y,A,B,SF,XO,YO,CMRAD,PHI,OLAM)
C***********************************************************************
C*
C*       SUBROUTINE TMXYPL COMPUTES THE GEOGRAPHIC COORDINATES- LATITUDE
C*     AND LONGITUDE - GIVEN THE X,Y COORDINATES OF THE TRANSVERSE
C*     MERCATOR PROJECTION. THE EQUATIONS USED TO COMPUTE THE LONGITUDE
C*     AND LATITUDE ARE FROM THOMAS (1952). SUBROUTINE FPLAT IS USED
C*     TO COMPUTE THE FOOT-POINT LATITUDE.
C*
C*
C*       INPUT;
C*             X   -EASTING COORDINATE OF THE TRANSVERSE MERCATOR
C*                  PROJECTION.
C*             Y   -NORTHING COORDINATE OF THE TRANSVERSE MERCATOR
C*                  PROJECTION.
C*             A   -SEMI-MAJOR AXES OF THE REFERENCE ELLIPSOID.
C*             B   -SEMI-MINOR AXES OF THE REFERENCE ELLIPSOID.
C*             SF - SCALE OF THE CENTRAL MERIDIAN.
C*             XO - FALSE EASTING OF THE CENTRAL MERIDIAN.
C*             YO - FALSE NORTHING OF THE CENTRAL MERIDIAN.
C*             CMRAD - THE CENTRAL MERIDIAN,IN RADIANS.
C*
C*       OUTPUT:
C*             PHI -LATITUDE OF THE POINT IN RADIANS
C*             OLAM-LONGITUDE OF THE POINT IN RADIANS
C*
C*
C*     WRITTEN:  R.R. STEEVES, MAY, 1977
C*
C*     Modified: Ken W. Schuurman ( To eliminate exponent overflow and
C*                                  underflow problems)
C*
C***********************************************************************
      IMPLICIT REAL*8(A-H,O-Z)
      X=(X-XO)/SF
      Y=(Y-YO)/SF
      E=DSQRT((A**2-B**2)/A**2)
      CALL FPLAT(A,B,Y,PHI1)
      T=DTAN(PHI1)
      SP=DSIN(PHI1)
      CP=DCOS(PHI1)
      ETA=DSQRT((A**2-B**2)/B**2*CP**2)
      DN=A/DSQRT(1.0D0-E**2*SP**2)
      DM=A*(1.0D0-E**2)/DSQRT((1.0D0-E**2*SP**2)**3)
      PHI=PHI1-T*X**2/2.0D0/DM/DN+T*X**4/24.0D0/DM/DN**3*(5.0D0+3.0D0*
     1   T**2+ETA**2-4.0D0*ETA**4-9.0D0*ETA**2*T**2)-T*X**6/720.0D0/DM/
     2   DN**5*(61.0D0+90.0D0*T**2+46.0D0*ETA**2+45.0D0*T**4-252.0D0*T**
     3   2*ETA**2-3.0D0*ETA**4+100.0D0*ETA**6-66.0D0*T**2*ETA**4-90.0D0
     4   *T**4*ETA**2+88.0D0*ETA**8+225.0D0*T**4*ETA**4+84.0D0*T**2*
     5   ETA**6-192.0D0*T**2*ETA**8)
      PHI = PHI + T * X*(X/DN)**7 / 40320.0D0 / DM *
     1    (1385.0D0 + 3633.0D0*T**2 + 4095.0D0*T**4 + 1575.0D0*T**6)
      DLAM=(X/DN-(X/DN)**3/6.0D0*(1.0D0+2.0D0*T**2+ETA**2)+(X/DN)**5/
     1   120.0D0*(5.0D0+6.0D0*ETA**2+28.0D0*T**2-3.0D0*ETA**4+8.0D0*T**2
     2   *ETA**2+24.0D0*T**4-4.0D0*ETA**6+4.0D0*T**2*ETA**4+24.0D0*T**2*
     3   ETA**6)-(X/DN)**7/5040.0D0*(61.0D0+662.0D0*T**2+1320.0D0*T**4+
     4   720.0D0*T**6))/CP
      OLAM=CMRAD+DLAM
      X=X*SF+XO
      Y=Y*SF+YO
      RETURN
      END
      SUBROUTINE TMPLXY(PHI,ELAM,A,B,SF,XO,YO,CMRAD,X,Y)
C
C         NAME:       TMPLXY
C
C         TYPE:       SUBROUTINE
C
C         FUNCTION:   COMPUTES THE X,Y COORDINATES FOR THE TRANSVERSE
C                     MERCATOR PROJECTION GIVEN THE GEOGRAPHIC
C                     COORDINATES (LATITUDE & LONGITUDE)  - THOMAS (1952
C
C         VERSION:    VERSION 1 (IBM)
C
C         ANALYST:    R.R.STEEVES  (MAY 1977)
C
C         MODIFIED:   K.W.SCHUURMAN   (JANUARY 1981)
C
C         STATEMENT:  CALL TMPLXY(PHI,ELAM,A,B,SF,XO,YO,CMRAD,X,Y)
C
C
C                     NAME   I/O DESCRIPTION
C                     ----   --- -----------
C
C                     PHI     I  LATITUDE IN RADIANS (POSITIVE NORTH)
C                     ELAM    I  LONGITUDE IN RADIANS (POSITIVE EAST)
C                     A       I  SEMI-MAJOR AXIS OF REFERENCE ELLIPSOID
C                     B       I  SEMI-MINOR AXIS OF REFERENCE ELLIPSOID
C                     SF      I  SCALE OF THE CENTRAL MERIDIAN
C                     XO      I  FALSE EASTING OF THE CENTRAL MERIDIAN
C                     YO      I  FALSE NORTHING
C                     CMRAD   I  LONGITUDE OF THE CENTRAL MERIDIAN (RADI
C                     X       O  TRANSVERSE MERCATOR EASTING
C                     Y       O  TRANSVERSE MERCATOR NORTHING
C
C         LANGUAGE:   FORTRAN G1
C
C         EXTERNALS:  MERARC(PHI, A, B, SPHI)
C
C
      IMPLICIT REAL*8(A-H,O-Z)
      DLAM=ELAM-CMRAD
      SP=DSIN(PHI)
      CP=DCOS(PHI)
      T=DTAN(PHI)
      E=DSQRT((A**2-B**2)/A**2)
      ETA=DSQRT((A**2-B**2)/B**2*CP**2)
      CALL MERARC(PHI,A,B,SPHI)
      DN=A/DSQRT(1.0D0-E**2*SP**2)
      X=DN*(DLAM*CP+DLAM**3*CP**3/6.0D0*(1.0D0-T**2+ETA**2)+DLAM**5*CP
     1   **5/120.0D0*(5.0D0-18.0D0*T**2+T**4+14.0D0*ETA**2-58.0D0*T**2*
     2   ETA**2+13.D0*ETA**4+4.D0*ETA**6-64.D0*ETA**4*T**2-24.D0*ETA**6
     3   *T**2) +DLAM**7/5040.0D0*CP**7*(61.0D0-479.0D0*T**2+179.0D0*
     4   T**4-T**6))
      Y=SPHI+DN*   (DLAM**2/2.0D0*SP*CP+DLAM**4/24.0D0*SP*CP**3*(5.0D0-
     1   T**2+9.0D0*ETA**2+4.0D0*ETA**4)+DLAM**6/720.0D0*SP*CP**5*
     2   (61.0D0-58.0D0*T**2+T**4+270.0D0*ETA**2-330.0D0*T**2*ETA**2
     3   +445.D0*ETA**4+324.D0*ETA**6-680.D0*ETA**4*T**2+88.D0*ETA**8
     4   -600.D0*ETA**6*T**2-192.D0*ETA**8*T**2)+DLAM**8/40320.D0*SP*CP*
     5   *7*(1385.D0-3111.D0*T**2+543.D0*T**4-T**6))
      X=SF*X+XO
      Y=SF*Y+YO
      RETURN
      END
