
#include <math.h>

/*
 *      Convert geographic coordinates to utm.
 * Method used is Clarke 1866 spheriod, courtesy Des Shaw at AeroGeo.
 *  Old code, from gtoutm, does not work for NAD83.
 */

#define A  6367399.6893
#define B    16216.9438
#define C       17.2089
#define D        0.0225

void radoutm(latr,lonr,a1,b1,sf,xo,yo,cr,xutm,yutm)
      double latr,lonr,a1,b1,sf,xo,yo,cr,*xutm,*yutm;
  {double e1,e2;
   double t,et2,i,n,ma;
   e1 = 1.0 - b1*b1/(a1*a1);
   e2 = a1*a1/(b1*b1) - 1.0;
   t = tan(latr);
   et2 = e2 * pow(cos(latr), 2.0);
   i = cr - lonr;
   n = a1 / sqrt(1.0 - e1*pow(sin(latr), 2.0));
   ma = A*latr - B*sin(2.0*latr) + C*sin(4.0*latr) - D*sin(6.0*latr);
   *xutm = sf*(i*n*cos(latr)*(1.0 + i*i/6.0*pow(cos(latr), 2.0)*
              (1.0 - t*t + et2) + pow(i, 4.0)/120.0*pow(cos(latr), 4.0)*(5.0 +
                   14.0*et2 - 18.0*t*t - 58.0*et2 + pow(t, 4.0))));
   *yutm = sf*(ma + i*i/2.0*n*sin(latr)*cos(latr)*(
         1.0 + i*i/12.0*pow(cos(latr), 2.0)*(5.0 - t*t + 9.0*et2 +4.0*et2*et2) +
              pow(i, 4.0)/360.0*pow(cos(latr), 4.0)*(61.0 + 270.0*et2 -
              58.0*t*t + pow(t, 4.0) - 330.0*t*t*et2)));
   *xutm = *xutm + xo;
   *yutm = *yutm + yo;}
