
#include <stdio.h>
#include <tfictypes.h>

extern bool debug;

static double fp(p,a,c)
      double p,a,c[];
  {/* looks similar to derivative of arc_length() */
   extern double cos();
   return(a*(c[0]-2*c[1]*cos(2*p)+4*c[2]*cos(4*p)
             -6*c[3]*cos(6*p)+8*c[4]*cos(8*p)));}

double fplat(a,b,y)
      double a, /* semi-major axes of the reference ellipsoid. */
             b, /* semi-minor axes of the reference ellipsoid. */
             y; /* northing of the point for which the foot-point
                   latitude is to be computed. */
  {/* Return the foot-point latitude (in radians) required in
      transforming transverse mercator plane coordinates x,y to
      ellipsoidal coordinates.
      Written by: R.R. STEEVES, JUNE, 1977
      Translated to C by Tom Rushworth 14 March 1989 */
   double c[5],dphi,phi;
   int max;
   extern double fabs();
   extern void al_coefs();
   extern double arc_len();
   al_coefs(a,b,c);
   phi = y/a;
   if (debug)
     {fprintf(stderr,"fplat: phi=%.6lg  y=%.6lg  a=%.6lg\n",phi,y,a);
      max = 5;}
   do
     {phi -= dphi = (arc_len(phi,a,c)-y) / fp(phi,a,c);
      if (debug)
        {fprintf(stderr,"fplat: dphi=%.6lg\n",dphi);
         if (--max < 0)
           {break;}}}
   while (fabs(dphi) >= 1e-11);
   return(phi);}
