program GridGen (input, output);

(*
 *		Generate a geographics grid for gtoutm.
 *)

const

	Eps = 0.0000002778;

var

	LatD, LatM, LatS, LonD, LonM, LonS: real;
	Lat, Lon: real;
	MinLat, MinLon, DLat, DLon, MaxLat, MaxLon: real;
	PN: integer;

procedure FromDMS (D, M, S: real; var L: real);
begin
	L := D + M/60.0 + S/3600.0;
end (* FromDMS *);

procedure ToDMS (var D, M, S: real; L: real);
begin
	D := trunc (L);
	M := trunc ((L - D)*60.0);
	S := ((L - D)*60.0 - M) * 60.0;
end (* ToDMS *);

begin

	message ('All coordinates entered are of the form degrees minutes seconds.');
	message ('	Enter minimum lat and long:');
	readln (LatD, LatM, LatS, LonD, LonM, LonS);
	FromDMS (LatD, LatM, LatS, MinLat);
	FromDMS (LonD, LonM, LonS, MinLon);
	message ('	Enter increment in lat and long:');
	readln (LatD, LatM, LatS, LonD, LonM, LonS);
	FromDMS (LatD, LatM, LatS, DLat);
	FromDMS (LonD, LonM, LonS, DLon);
	message ('	Enter maximum lat and long:');
	readln (LatD, LatM, LatS, LonD, LonM, LonS);
	FromDMS (LatD, LatM, LatS, MaxLat);
	FromDMS (LonD, LonM, LonS, MaxLon);

	MaxLat := MaxLat + Eps;
	MaxLon := MaxLon + Eps;

	PN := 0;
	Lat := MinLat;
	while Lat <= MaxLat do begin
		Lon := MinLon;
		while Lon <= MaxLon do begin
			ToDMS (LatD, LatM, LatS, Lat+Eps);
			ToDMS (LonD, LonM, LonS, Lon+Eps);
			PN := succ (PN);
			writeln (PN:10, LatD:7:1, LatM:5:1, LatS:6:2,
				LonD:7:1, LonM:5:1, LonS:6:2);
			Lon := Lon + DLon
		end (* while Lon <= MaxLon *);
		Lat := Lat + DLat
	end (* while Lat <= MaxLat *)

end (* GridGen *).
