
void al_coefs(a,b,c)
      double a,b,c[];
  {/* set up coefficients for fplat and merarc */
   double e2,e4,e6,e8;
   e2 = (a*a-b*b)/(a*a);
   e4 = e2*e2;
   e6 = e4*e2;
   e8 = e6*e2;
   c[0] = 1-e2/4-3*e4/64-5*e6/256-175*e8/16384;
   c[1] = 3.0/8*(e2+e4/4+15*e6/128-455*e8/4096);
   c[2] = 15.0/256*(e4+3*e6/4-77*e8/128);
   c[3] = 35.0/3072*(e6-41*e8/32);
   c[4] = -315*e8/131072;}

double arc_len(p,a,c)
      double p,a,c[];
  {/* coefficients c[] set by coefs above */
   extern double sin();
   return(a*(c[0]*p-c[1]*sin(2*p)+c[2]*sin(4*p)-c[3]*sin(6*p)+c[4]*sin(8*p)));}

double merarc(phi,a,b)
      double phi,a,b;
  {/* Return the meridian arc length from the equator to the latitude
      phi on the elipsiod defined by a and b.
      Note:    The computed arc length is accurate to approximately
               10 micrometres over the entire range: equator to pole.
      DATE:       MAY 1977
      ANALYST     R.R.STEEVES AND G.BOWIE
      Translated to C by Tom Rushworth 14 March 1989 */
   double c[5];
   al_coefs(a,b,c);
   return(arc_len(phi,a,c));}
