
#include <math.h>

void rad_utm(phi,elam,a,b,sf,xo,yo,cmrad,x,y)
      double phi,elam,a,b,sf,xo,yo,cmrad,*x,*y;
  {/*  Translated to C by Tom Rushworth 15 March 89 from original Fortran:
      FUNCTION:   COMPUTES THE X,Y COORDINATES FOR THE TRANSVERSE
                  MERCATOR PROJECTION GIVEN THE GEOGRAPHIC
                  COORDINATES (LATITUDE & LONGITUDE)  - THOMAS (1952
      VERSION:    VERSION 1 (IBM)
      ANALYST:    R.R.STEEVES  (MAY 1977)
      MODIFIED:   K.W.SCHUURMAN   (JANUARY 1981)
                  NAME   I/O DESCRIPTION
                  ----   --- -----------
                  PHI     I  LATITUDE IN RADIANS (POSITIVE NORTH)
                  ELAM    I  LONGITUDE IN RADIANS (POSITIVE EAST)
                  A       I  SEMI-MAJOR AXIS OF REFERENCE ELLIPSOID
                  B       I  SEMI-MINOR AXIS OF REFERENCE ELLIPSOID
                  SF      I  SCALE OF THE CENTRAL MERIDIAN
                  XO      I  FALSE EASTING OF THE CENTRAL MERIDIAN
                  YO      I  FALSE NORTHING
                  CMRAD   I  LONGITUDE OF THE CENTRAL MERIDIAN (RADI
                  X       O  TRANSVERSE MERCATOR EASTING
                  Y       O  TRANSVERSE MERCATOR NORTHING */
   double dlam,dlam2,dlam2o2,sp,sp2,cp,cp2,t,t2,eta,eta2,dn;
   extern double merarc();
   dlam = elam-cmrad;  dlam2 = dlam*dlam;
   dlam2o2 = dlam2/2;
   sp = sin(phi);  sp2 = sp*sp;
   cp = cos(phi);  cp2 = cp*cp;
   t = tan(phi);  t2 = t*t;
   eta = sqrt(eta2 = (a*a-b*b)*cp2/(b*b));
   dn = a/sqrt(1.0-(a*a-b*b)*sp2/(a*a));
   *x = dn*dlam*cp*(1+
          dlam2*cp2/6.0*
           ((1.0-t2+eta2)
            +dlam2*cp2/20.0*
             ((5.0+(t2-18.0)*t2
               +((14-58*t2)+((13-64*t2)+(4-24*t2)*eta2)*eta2)*eta2)
              +dlam2/42.0*cp2*(61.0+(-479.0+(179.0-t2)*t2)*t2))));
   *y = merarc(phi,a,b)+dn*dlam2o2*sp*cp
      *(1.0
        +dlam2o2*cp2/6*
         ((5-t2+(9+4*eta2)*eta2)
          +dlam2o2*cp2/15*
           ((61+(t2-58)*t2
               +(30*(9-11*t2)
                 +(5*(89-136*t2)
                   +(12*(27-50*t2)+8*(11-24*t2)*eta2)*eta2)*eta2)*eta2)
            +dlam2o2*cp2/28*(1385+(-3111+(543-t2)*t2)*t2))));
   *x = sf * *x + xo;
   *y = sf * *y + yo;}
